<?php
/**
* This is the function/template used to 
* generate the display for a record
*
* This file is released under the GNU Public License
* @author Casey Bisson <cbisson@mail.plymouth.edu> 
* @version 0.1 - Aug 25 2006
*/

//error_reporting(E_ALL);

class Scrib_default_templates {

	public function summary($bibr){

		global $scrib_importer;
		$result = '<ul class="summaryrecord">';

		if($bibr['img']['thumb']['url']){
			$result .= '<li class="image">[[bookjacket|<img class="bookjacket" src="'. $bibr['img']['thumb']['url'] .'" width="'. $bibr['img']['thumb']['width'] .'" height="'. $bibr['img']['thumb']['height'] .'" alt="'. str_replace(array('[',']'), array('{','}'), htmlentities($bibr['title'][0], ENT_QUOTES, UTF-8)) .'" />]]</li>';
		}else{
			$result .= '<li class="image">[[bookjacket|<img class="bookjacket" src="http://img.scriblio.net/jacket/blank_'. urlencode(strtolower($bibr['format'][0])) .'.png" width="100" height="135" alt="'. str_replace(array('[',']'), array('{','}'), htmlentities($bibr['title'][0], ENT_QUOTES, UTF-8)) .'" />]]</li>';
		}

		$result .= '<li class="attribution"><h3>Attribution</h3>'. $bibr['attribution'][0] .'</li>';
		$result .= '<li class="format"><h3>Format</h3>'. $bibr['format'][0] .'</li>';
		$result .= '<li class="pubyear"><h3>Published</h3>'. $bibr['pubyear'][0] .'</li>';
		
		if(count($bibr['url']) > 0){
			$result .= '<li class="links">';
			$result .= '<h3>Links</h3>';
	
			$result .= '<ul>';
			foreach($bibr['url'] as $temp){
				$result .= '<li>' . $temp . '</li>';
			}
			$result .= '</ul>';
			$result .= '</li>';
		}

		if($bibr['shortdescription'])
			$result .= '<li class="reviews"><h3>Description</h3>'. $bibr['shortdescription'] .'</li>';

		// build a block of tags
		$tags =  NULL;
		if($bibr['subjkey']){
			foreach($bibr['subjkey'] as $temp){
				$tags[] = '<a href="ScribCatBase/subject/' . urlencode($temp) . '" rel="tag">' . $temp . '</a>';
			}
		}

		if($bibr['author']){
			foreach($bibr['author'] as $temp){
				$tags[] = '<a href="ScribCatBase/author/' . urlencode($temp) . '" rel="tag">' . $temp . '</a>';
			}
		}

		if($tags){
			$result .= '<li class="tags"><h3>Tags</h3> '. implode(' &middot; ', $tags) .'</li>';
		}
		// end tag block

		$result .='</ul>';
		
//		echo($result);
		return($result);
	}		
	//




	//
	// take the array and return the full record display
	//
	public function full($bibr){
		global $scrib_importer;
		$result = '<ul class="fullrecord">';

		if($bibr['img']['thumb']['url']){
			$result .= '<li class="image">[[bookjacket|<img class="bookjacket" src="'. $bibr['img']['thumb']['url'] .'" width="'. $bibr['img']['thumb']['width'] .'" height="'. $bibr['img']['thumb']['height'] .'" alt="'. str_replace(array('[',']'), array('{','}'), htmlentities($bibr['title'][0], ENT_QUOTES, UTF-8)) .'" />]]</li>';
		}else{
			$result .= '<li class="image">[[bookjacket|<img class="bookjacket" src="http://img.scriblio.net/jacket/blank_'. urlencode(strtolower($bibr['format'][0])) .'.png" width="100" height="135" alt="'. str_replace(array('[',']'), array('{','}'), htmlentities($bibr['title'][0], ENT_QUOTES, UTF-8)) .'" />]]</li>';
		}

		if($bibr['title']){
			$result .= '<li class="title">';
			if(count($bibr['title']) > 1){
				$result .= '<h3>Titles</h3>';
			}else{
				$result .= '<h3>Title</h3>';
			}
			
			$result .= '<ul>';
			foreach($bibr['title'] as $temp){
				$result .= '<li>' . $temp . '</li>';
			}
			$result .= '</ul>';
			$result .= '</li>';
		}


		$result .= '<li class="attribution"><h3>Attribution</h3>'. $bibr['attribution'][0] .'</li>';
		$result .= '<li class="format"><h3>Format</h3>'. $bibr['format'][0] .'</li>';
		$result .= '<li class="pubyear"><h3>Published</h3>'. $bibr['pubyear'][0] .'</li>';

		$result .= '<li class="availability"><h3>Availability</h3>[[availability|'. $bibr['the_sourceid'] .']]</a>';

		if(count($bibr['callnumber']) > 0){
			$result .= '<li class="callnumber">';
			$result .= '<h3>Call Number</h3>';
	
			$result .= '<ul>';
			foreach($bibr['callnumber'] as $temp){
				$result .= '<li>' . $temp . '</li>';
			}
			$result .= '</ul>';
			$result .= '</li>';
		}

		if(count($bibr['url']) > 0){
			$result .= '<li>';
			$result .= '<h3>links</h3>';
	
			$result .= '<ul class="links">';
			foreach($bibr['url'] as $temp){
				$result .= '<li>' . $temp . '</li>';
			}
			$result .= '</ul>';
			$result .= '</li>';
		}

		if($bibr['shortdescription'])
			$result .= '<li class="reviews"><h3>Description and Reviews</h3>'. $bibr['shortdescription'] .' [[reviews|asin='. $bibr['asin'] .']]</li>';

		if($bibr['author']){
			$result .= '<li class="author">';
			if(count($bibr['author']) > 1){
				$result .= '<h3>Authors</h3>';
			}else{
				$result .= '<h3>Author</h3>';
			}
			
			$result .= '<ul>';
			foreach($bibr['author'] as $temp){
				$result .= '<li><a href="ScribCatBase/author/' . urlencode($temp) . '">' . $temp . '</a></li>';
			}
			$result .= '</ul>';
			$result .= '</li>';
		}

	
		if(count($bibr['subject']) > 0){
			$result .= '<li class="subject">';
			$result .= '<h3>Subject</h3>';
	
			$result .= '<ul>';
			foreach($bibr['subject'] as $temp){
				$result .= '<li><a href="ScribCatBase/subject/' . urlencode(strtolower(str_replace(' -- ', '|', ($temp)))) . '">' . $temp . '</a></li>';
			}
			$result .= '</ul></li>';
		}
		
	
		if($bibr['notes']){
			$result .= '<li class="notes">';
			$result .= '<h3>Notes</h3>';
	
			$result .= '<ul>';
			foreach($bibr['notes'] as $temp){
				$result .= '<li>' . $temp . '</li>';
			}
			$result .= '</ul></li>';
		}
	
	
		if($bibr['contents']){
			$result .= '<li class="contents">';
			$result .= '<h3>Contents</h3>';
	
			$result .= '<ul>'. $bibr['contents'][0] .'</ul></li>';
		}


		if($bibr['isbn']){
			$result .= '<li class="isbn"><h3>ISBN</h3>';
			$result .= '<ul>';
			foreach($bibr['isbn'] as $temp){
				$result .= '<li>'. strtolower($temp) . '</li>';
			}
			$result .= '</ul>';
		
			$result .= '</li>';
		}

		if($bibr['lccn']){
			$result .= '<li class="lccn"><h3>LCCN</h3>';
			$result .= '<ul>';
			foreach($bibr['lccn'] as $temp){
				$result .= '<li>'. strtolower($temp) . '</li>';
			}
			$result .= '</ul>';
		
			$result .= '</li>';
		}


		if($bibr['tags']){
			$result .= '<li class="tags"><h3>Tags</h3>';
			$result .= '<ul>';
			foreach($bibr['tags'] as $temp){
				$result .= '<li>[tag]'. strtolower($temp) . '[/tag]</li>';
			}
			$result .= '</ul></li>';
		}
/*
		if($bibr['asin'])
			$result .= '<li class="searchinside"><h3>Search Inside</h3>[[searchinside|'. $bibr['asin'] .']]</li>';

		if($bibr['asin'])
			$result .= '<li class="amazon_link"><h3>Images and Reviews</h3>additional catalog content provided by <a href="'. $bibr['amznurl'] .'">Amazon.com</a></li>';

		if($tags){
			$result .= '<li class="related"><h3>Related</h3>[[related|'. strip_tags(implode(' ', $tags)) .']]</li>';
		}
*/
		$result .= '</ul>';

		return($result);
	}

}
?>