﻿<?php
require_once('../../../../wp-config.php'); 
require_once('../../../../wp-admin/admin-functions.php'); 

@header('Content-type: ' . get_option('html_type') . '; charset=' . get_option('blog_charset'));
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
<head>
<link rel="stylesheet" href="<?php echo get_option('siteurl') ?>/wp-admin/wp-admin.css?version=<?php bloginfo('version'); ?>" type="text/css" />
</head>
<body>
<?php

$importers = array ();
$importers_root = ABSPATH . PLUGINDIR .'/scriblio/import/';
//get_settings('siteurl') .'/'. PLUGINDIR .'/scriblio/import/'

// Files in wp-content/plugins directory
$plugins_dir = @ dir( $importers_root);

if ( $plugins_dir ) {
	while (($file = $plugins_dir->read() ) !== false ) {
		if ( preg_match( '|^\.+$|', $file ))
			continue;
		if ( is_dir( $importers_root.'/'.$file ) ) {
			$plugins_subdir = @ dir( $importers_root.'/'.$file );
			if ( $plugins_subdir ) {
				while (($subfile = $plugins_subdir->read() ) !== false ) {
					if ( preg_match( '|^\.+$|', $subfile ))
						continue;
					if ( preg_match( '|\.php$|', $subfile ))
						$plugin_files[] = "$file/$subfile";
				}
			}
		} else {
			if ( preg_match( '|\.php$|', $file ))
				$plugin_files[] = $file;
		}
	}
}

if ( !$plugins_dir || !$plugin_files )
	return $wp_plugins;

foreach ( $plugin_files as $plugin_file ) {
	if ( !is_readable( "$importers_root/$plugin_file" ) )
		continue;

	$plugin_data = get_plugin_data( "$importers_root/$plugin_file" );

	if ( empty ( $plugin_data['Name'] ) )
		continue;

	$wp_plugins[plugin_basename( $plugin_file )] = $plugin_data;
}

uasort( $wp_plugins, create_function( '$a, $b', 'return strnatcasecmp( $a["Name"], $b["Name"] );' ));

//print_r($wp_plugins);
$plugins = $wp_plugins;


if (!current_user_can('edit_plugins') || empty($plugins)) {
	echo '<p>';
	_e("Couldn&#8217;t open plugins directory or there are no plugins available."); // TODO: make more helpful
	echo '</p>';
} else {
?>
<table class="widefat plugins">
	<thead>
	<tr>
		<th style="text-align: center"><?php _e('Action'); ?></th>
		<th><?php _e('Plugin'); ?></th>
		<th style="text-align: center"><?php _e('Version'); ?></th>
		<th><?php _e('Description'); ?></th>
	</tr>
	</thead>
<?php
	$style = '';

	foreach($plugins as $plugin_file => $plugin_data) {
		$style = ('class="alternate"' == $style|| 'class="alternate active"' == $style) ? '' : 'alternate';

		$toggle = '<a href="' . $plugin_file . '" class="edit">Import &raquo;</a>';

		$plugins_allowedtags = array('a' => array('href' => array(),'title' => array()),'abbr' => array('title' => array()),'acronym' => array('title' => array()),'code' => array(),'em' => array(),'strong' => array());

		// Sanitize all displayed data
		$plugin_data['Title']       = wp_kses($plugin_data['Title'], $plugins_allowedtags);
		$plugin_data['Version']     = wp_kses($plugin_data['Version'], $plugins_allowedtags);
		$plugin_data['Description'] = wp_kses($plugin_data['Description'], $plugins_allowedtags);
		$plugin_data['Author']      = wp_kses($plugin_data['Author'], $plugins_allowedtags);

		if ( $style != '' )
			$style = 'class="' . $style . '"';

		echo "
	<tr $style>
		<td class='togl'>$toggle</td>".
		str_replace('<a href', '<a target="_parent" href', "
		<td class='name'>{$plugin_data['Title']}</td>
		<td class='vers'>{$plugin_data['Version']}</td>
		<td class='desc'><p>{$plugin_data['Description']} <cite>".sprintf(__('By %s'), $plugin_data['Author']).".</cite></p></td>");
		echo"
	</tr>";
	}
?>

</table>
<?php } ?>
</body></html>